## UDisksMDRaid

UDisksMDRaid — Generated C code for the org.freedesktop.UDisks2.MDRaid D-Bus interface

## Functions

GDBusInterfaceInfo * | udisks_mdraid_interface_info ()
guint | udisks_mdraid_override_properties ()
void | udisks_mdraid_call_remove_device ()
gboolean | udisks_mdraid_call_remove_device_finish ()
gboolean | udisks_mdraid_call_remove_device_sync ()
void | udisks_mdraid_complete_remove_device ()
void | udisks_mdraid_call_add_device ()
gboolean | udisks_mdraid_call_add_device_finish ()
gboolean | udisks_mdraid_call_add_device_sync ()
void | udisks_mdraid_complete_add_device ()
void | udisks_mdraid_call_start ()
gboolean | udisks_mdraid_call_start_finish ()
gboolean | udisks_mdraid_call_start_sync ()
void | udisks_mdraid_complete_start ()
void | udisks_mdraid_call_stop ()
gboolean | udisks_mdraid_call_stop_finish ()
gboolean | udisks_mdraid_call_stop_sync ()
void | udisks_mdraid_complete_stop ()
void | udisks_mdraid_call_set_bitmap_location ()
gboolean | udisks_mdraid_call_set_bitmap_location_finish ()
gboolean | udisks_mdraid_call_set_bitmap_location_sync ()
void | udisks_mdraid_complete_set_bitmap_location ()
void | udisks_mdraid_call_request_sync_action ()
gboolean | udisks_mdraid_call_request_sync_action_finish ()
gboolean | udisks_mdraid_call_request_sync_action_sync ()
void | udisks_mdraid_complete_request_sync_action ()
void | udisks_mdraid_call_delete ()
gboolean | udisks_mdraid_call_delete_finish ()
gboolean | udisks_mdraid_call_delete_sync ()
void | udisks_mdraid_complete_delete ()
GVariant * | udisks_mdraid_get_active_devices ()
const gchar * | udisks_mdraid_get_bitmap_location ()
guint64 | udisks_mdraid_get_chunk_size ()
guint | udisks_mdraid_get_degraded ()
const gchar * | udisks_mdraid_get_level ()
const gchar * | udisks_mdraid_get_name ()
guint | udisks_mdraid_get_num_devices ()
guint64 | udisks_mdraid_get_size ()
const gchar * | udisks_mdraid_get_sync_action ()
gdouble | udisks_mdraid_get_sync_completed ()
guint64 | udisks_mdraid_get_sync_rate ()
guint64 | udisks_mdraid_get_sync_remaining_time ()
const gchar * | udisks_mdraid_get_uuid ()
GVariant * | udisks_mdraid_dup_active_devices ()
gchar * | udisks_mdraid_dup_bitmap_location ()
gchar * | udisks_mdraid_dup_level ()
gchar * | udisks_mdraid_dup_name ()
gchar * | udisks_mdraid_dup_sync_action ()
gchar * | udisks_mdraid_dup_uuid ()
void | udisks_mdraid_set_active_devices ()
void | udisks_mdraid_set_bitmap_location ()
void | udisks_mdraid_set_chunk_size ()
void | udisks_mdraid_set_degraded ()
void | udisks_mdraid_set_level ()
void | udisks_mdraid_set_name ()
void | udisks_mdraid_set_num_devices ()
void | udisks_mdraid_set_size ()
void | udisks_mdraid_set_sync_action ()
void | udisks_mdraid_set_sync_completed ()
void | udisks_mdraid_set_sync_rate ()
void | udisks_mdraid_set_sync_remaining_time ()
void | udisks_mdraid_set_uuid ()
void | udisks_mdraid_proxy_new ()
UDisksMDRaid * | udisks_mdraid_proxy_new_finish ()
UDisksMDRaid * | udisks_mdraid_proxy_new_sync ()
void | udisks_mdraid_proxy_new_for_bus ()
UDisksMDRaid * | udisks_mdraid_proxy_new_for_bus_finish ()
UDisksMDRaid * | udisks_mdraid_proxy_new_for_bus_sync ()
UDisksMDRaid * | udisks_mdraid_skeleton_new ()

## Properties

GVariant * | active-devices | Read / Write
gchar * | bitmap-location | Read / Write
GVariant * | child-configuration | Read / Write
guint64 | chunk-size | Read / Write
guint | degraded | Read / Write
gchar * | level | Read / Write
gchar * | name | Read / Write
guint | num-devices | Read / Write
gboolean | running | Read / Write
guint64 | size | Read / Write
gchar * | sync-action | Read / Write
gdouble | sync-completed | Read / Write
guint64 | sync-rate | Read / Write
guint64 | sync-remaining-time | Read / Write
gchar * | uuid | Read / Write

## Signals

gboolean | handle-add-device | Run Last
gboolean | handle-delete | Run Last
gboolean | handle-remove-device | Run Last
gboolean | handle-request-sync-action | Run Last
gboolean | handle-set-bitmap-location | Run Last
gboolean | handle-start | Run Last
gboolean | handle-stop | Run Last

## Types and Values

| UDisksMDRaid
struct | UDisksMDRaidIface
struct | UDisksMDRaidProxy
struct | UDisksMDRaidProxyClass
struct | UDisksMDRaidSkeleton
struct | UDisksMDRaidSkeletonClass

## Object Hierarchy

        GInterface
        ╰── UDisksMDRaid
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── UDisksMDRaidSkeleton
        │       ╰── UDisksLinuxMDRaid
        ╰── GDBusProxy
            ╰── UDisksMDRaidProxy

## Prerequisites

UDisksMDRaid requires GObject.

## Implemented Interfaces

UDisksMDRaidProxy implements GDBusInterface, GInitable, GAsyncInitable and UDisksMDRaid.

UDisksMDRaidSkeleton implements GDBusInterface and UDisksMDRaid.

## Known Implementations

UDisksMDRaid is implemented by UDisksLinuxMDRaid, UDisksMDRaidProxy and UDisksMDRaidSkeleton.

## Description

This section contains code for working with the org.freedesktop.UDisks2.MDRaid D-Bus interface in C.

## Functions

### udisks_mdraid_interface_info ()

    GDBusInterfaceInfo *
    udisks_mdraid_interface_info (void);

Gets a machine-readable description of the org.freedesktop.UDisks2.MDRaid D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

Since: 2.0.0

### udisks_mdraid_override_properties ()

    guint
    udisks_mdraid_override_properties (GObjectClass *klass,
                                       guint property_id_begin);

Overrides all GObject properties in the UDisksMDRaid interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

Since: 2.0.0

### udisks_mdraid_call_remove_device ()

    void
    udisks_mdraid_call_remove_device (UDisksMDRaid *proxy,
                                      const gchar *arg_device,
                                      GVariant *arg_options,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

Asynchronously invokes the `RemoveDevice()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_remove_device_finish()` to get the result of the operation.

See `udisks_mdraid_call_remove_device_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_device | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_remove_device_finish ()

    gboolean
    udisks_mdraid_call_remove_device_finish
                                   (UDisksMDRaid *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_mdraid_call_remove_device()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_remove_device()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_remove_device_sync ()

    gboolean
    udisks_mdraid_call_remove_device_sync (UDisksMDRaid *proxy,
                                           const gchar *arg_device,
                                           GVariant *arg_options,
                                           GCancellable *cancellable,
                                           GError **error);

Synchronously invokes the `RemoveDevice()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_remove_device()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_device | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_remove_device ()

    void
    udisks_mdraid_complete_remove_device (UDisksMDRaid *object,
                                          GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `RemoveDevice()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_call_add_device ()

    void
    udisks_mdraid_call_add_device (UDisksMDRaid *proxy,
                                   const gchar *arg_device,
                                   GVariant *arg_options,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Asynchronously invokes the `AddDevice()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_add_device_finish()` to get the result of the operation.

See `udisks_mdraid_call_add_device_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_device | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_add_device_finish ()

    gboolean
    udisks_mdraid_call_add_device_finish (UDisksMDRaid *proxy,
                                          GAsyncResult *res,
                                          GError **error);

Finishes an operation started with `udisks_mdraid_call_add_device()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_add_device()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_add_device_sync ()

    gboolean
    udisks_mdraid_call_add_device_sync (UDisksMDRaid *proxy,
                                        const gchar *arg_device,
                                        GVariant *arg_options,
                                        GCancellable *cancellable,
                                        GError **error);

Synchronously invokes the `AddDevice()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_add_device()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_device | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_add_device ()

    void
    udisks_mdraid_complete_add_device (UDisksMDRaid *object,
                                       GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `AddDevice()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_call_start ()

    void
    udisks_mdraid_call_start (UDisksMDRaid *proxy,
                              GVariant *arg_options,
                              GCancellable *cancellable,
                              GAsyncReadyCallback callback,
                              gpointer user_data);

Asynchronously invokes the `Start()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_start_finish()` to get the result of the operation.

See `udisks_mdraid_call_start_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_start_finish ()

    gboolean
    udisks_mdraid_call_start_finish (UDisksMDRaid *proxy,
                                     GAsyncResult *res,
                                     GError **error);

Finishes an operation started with `udisks_mdraid_call_start()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_start()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_start_sync ()

    gboolean
    udisks_mdraid_call_start_sync (UDisksMDRaid *proxy,
                                   GVariant *arg_options,
                                   GCancellable *cancellable,
                                   GError **error);

Synchronously invokes the `Start()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_start()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_start ()

    void
    udisks_mdraid_complete_start (UDisksMDRaid *object,
                                  GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `Start()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_call_stop ()

    void
    udisks_mdraid_call_stop (UDisksMDRaid *proxy,
                             GVariant *arg_options,
                             GCancellable *cancellable,
                             GAsyncReadyCallback callback,
                             gpointer user_data);

Asynchronously invokes the `Stop()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_stop_finish()` to get the result of the operation.

See `udisks_mdraid_call_stop_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_stop_finish ()

    gboolean
    udisks_mdraid_call_stop_finish (UDisksMDRaid *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_mdraid_call_stop()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_stop()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_stop_sync ()

    gboolean
    udisks_mdraid_call_stop_sync (UDisksMDRaid *proxy,
                                  GVariant *arg_options,
                                  GCancellable *cancellable,
                                  GError **error);

Synchronously invokes the `Stop()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_stop()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_stop ()

    void
    udisks_mdraid_complete_stop (UDisksMDRaid *object,
                                 GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `Stop()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_call_set_bitmap_location ()

    void
    udisks_mdraid_call_set_bitmap_location
                                   (UDisksMDRaid *proxy,
                                    const gchar *arg_value,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `SetBitmapLocation()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_set_bitmap_location_finish()` to get the result of the operation.

See `udisks_mdraid_call_set_bitmap_location_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_value | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_set_bitmap_location_finish ()

    gboolean
    udisks_mdraid_call_set_bitmap_location_finish
                                   (UDisksMDRaid *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_mdraid_call_set_bitmap_location()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_set_bitmap_location()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_set_bitmap_location_sync ()

    gboolean
    udisks_mdraid_call_set_bitmap_location_sync
                                   (UDisksMDRaid *proxy,
                                    const gchar *arg_value,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `SetBitmapLocation()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_set_bitmap_location()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_value | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_set_bitmap_location ()

    void
    udisks_mdraid_complete_set_bitmap_location
                                   (UDisksMDRaid *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `SetBitmapLocation()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_call_request_sync_action ()

    void
    udisks_mdraid_call_request_sync_action
                                   (UDisksMDRaid *proxy,
                                    const gchar *arg_sync_action,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `RequestSyncAction()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_request_sync_action_finish()` to get the result of the operation.

See `udisks_mdraid_call_request_sync_action_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_sync_action | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_request_sync_action_finish ()

    gboolean
    udisks_mdraid_call_request_sync_action_finish
                                   (UDisksMDRaid *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_mdraid_call_request_sync_action()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_request_sync_action()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_request_sync_action_sync ()

    gboolean
    udisks_mdraid_call_request_sync_action_sync
                                   (UDisksMDRaid *proxy,
                                    const gchar *arg_sync_action,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `RequestSyncAction()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_request_sync_action()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_sync_action | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_request_sync_action ()

    void
    udisks_mdraid_complete_request_sync_action
                                   (UDisksMDRaid *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `RequestSyncAction()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_call_delete ()

    void
    udisks_mdraid_call_delete (UDisksMDRaid *proxy,
                               GVariant *arg_options,
                               GCancellable *cancellable,
                               GAsyncReadyCallback callback,
                               gpointer user_data);

Asynchronously invokes the `Delete()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_call_delete_finish()` to get the result of the operation.

See `udisks_mdraid_call_delete_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_call_delete_finish ()

    gboolean
    udisks_mdraid_call_delete_finish (UDisksMDRaid *proxy,
                                      GAsyncResult *res,
                                      GError **error);

Finishes an operation started with `udisks_mdraid_call_delete()`.

#### Parameters

proxy | A UDisksMDRaidProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_call_delete()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_call_delete_sync ()

    gboolean
    udisks_mdraid_call_delete_sync (UDisksMDRaid *proxy,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Delete()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_mdraid_call_delete()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksMDRaidProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.0.0

### udisks_mdraid_complete_delete ()

    void
    udisks_mdraid_complete_delete (UDisksMDRaid *object,
                                   GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `Delete()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.0.0

### udisks_mdraid_get_active_devices ()

    GVariant *
    udisks_mdraid_get_active_devices (UDisksMDRaid *object);

Gets the value of the "ActiveDevices" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `udisks_mdraid_dup_active_devices()` if on another thread.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

Since: 2.0.0

### udisks_mdraid_get_bitmap_location ()

    const gchar *
    udisks_mdraid_get_bitmap_location (UDisksMDRaid *object);

Gets the value of the "BitmapLocation" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `udisks_mdraid_dup_bitmap_location()` if on another thread.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

Since: 2.0.0

### udisks_mdraid_get_chunk_size ()

    guint64
    udisks_mdraid_get_chunk_size (UDisksMDRaid *object);

Gets the value of the "ChunkSize" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_degraded ()

    guint
    udisks_mdraid_get_degraded (UDisksMDRaid *object);

Gets the value of the "Degraded" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_level ()

    const gchar *
    udisks_mdraid_get_level (UDisksMDRaid *object);

Gets the value of the "Level" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `udisks_mdraid_dup_level()` if on another thread.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

Since: 2.0.0

### udisks_mdraid_get_name ()

    const gchar *
    udisks_mdraid_get_name (UDisksMDRaid *object);

Gets the value of the "Name" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `udisks_mdraid_dup_name()` if on another thread.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

Since: 2.0.0

### udisks_mdraid_get_num_devices ()

    guint
    udisks_mdraid_get_num_devices (UDisksMDRaid *object);

Gets the value of the "NumDevices" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_size ()

    guint64
    udisks_mdraid_get_size (UDisksMDRaid *object);

Gets the value of the "Size" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_sync_action ()

    const gchar *
    udisks_mdraid_get_sync_action (UDisksMDRaid *object);

Gets the value of the "SyncAction" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `udisks_mdraid_dup_sync_action()` if on another thread.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

Since: 2.0.0

### udisks_mdraid_get_sync_completed ()

    gdouble
    udisks_mdraid_get_sync_completed (UDisksMDRaid *object);

Gets the value of the "SyncCompleted" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_sync_rate ()

    guint64
    udisks_mdraid_get_sync_rate (UDisksMDRaid *object);

Gets the value of the "SyncRate" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_sync_remaining_time ()

    guint64
    udisks_mdraid_get_sync_remaining_time (UDisksMDRaid *object);

Gets the value of the "SyncRemainingTime" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value.

Since: 2.0.0

### udisks_mdraid_get_uuid ()

    const gchar *
    udisks_mdraid_get_uuid (UDisksMDRaid *object);

Gets the value of the "UUID" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `udisks_mdraid_dup_uuid()` if on another thread.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

Since: 2.0.0

### udisks_mdraid_dup_active_devices ()

    GVariant *
    udisks_mdraid_dup_active_devices (UDisksMDRaid *object);

Gets a copy of the "ActiveDevices" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

Since: 2.0.0

### udisks_mdraid_dup_bitmap_location ()

    gchar *
    udisks_mdraid_dup_bitmap_location (UDisksMDRaid *object);

Gets a copy of the "BitmapLocation" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.0.0

### udisks_mdraid_dup_level ()

    gchar *
    udisks_mdraid_dup_level (UDisksMDRaid *object);

Gets a copy of the "Level" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.0.0

### udisks_mdraid_dup_name ()

    gchar *
    udisks_mdraid_dup_name (UDisksMDRaid *object);

Gets a copy of the "Name" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.0.0

### udisks_mdraid_dup_sync_action ()

    gchar *
    udisks_mdraid_dup_sync_action (UDisksMDRaid *object);

Gets a copy of the "SyncAction" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.0.0

### udisks_mdraid_dup_uuid ()

    gchar *
    udisks_mdraid_dup_uuid (UDisksMDRaid *object);

Gets a copy of the "UUID" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.0.0

### udisks_mdraid_set_active_devices ()

    void
    udisks_mdraid_set_active_devices (UDisksMDRaid *object,
                                      GVariant *value);

Sets the "ActiveDevices" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_bitmap_location ()

    void
    udisks_mdraid_set_bitmap_location (UDisksMDRaid *object,
                                       const gchar *value);

Sets the "BitmapLocation" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_chunk_size ()

    void
    udisks_mdraid_set_chunk_size (UDisksMDRaid *object,
                                  guint64 value);

Sets the "ChunkSize" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_degraded ()

    void
    udisks_mdraid_set_degraded (UDisksMDRaid *object,
                                guint value);

Sets the "Degraded" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_level ()

    void
    udisks_mdraid_set_level (UDisksMDRaid *object,
                             const gchar *value);

Sets the "Level" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_name ()

    void
    udisks_mdraid_set_name (UDisksMDRaid *object,
                            const gchar *value);

Sets the "Name" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_num_devices ()

    void
    udisks_mdraid_set_num_devices (UDisksMDRaid *object,
                                   guint value);

Sets the "NumDevices" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_size ()

    void
    udisks_mdraid_set_size (UDisksMDRaid *object,
                            guint64 value);

Sets the "Size" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_sync_action ()

    void
    udisks_mdraid_set_sync_action (UDisksMDRaid *object,
                                   const gchar *value);

Sets the "SyncAction" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_sync_completed ()

    void
    udisks_mdraid_set_sync_completed (UDisksMDRaid *object,
                                      gdouble value);

Sets the "SyncCompleted" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_sync_rate ()

    void
    udisks_mdraid_set_sync_rate (UDisksMDRaid *object,
                                 guint64 value);

Sets the "SyncRate" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_sync_remaining_time ()

    void
    udisks_mdraid_set_sync_remaining_time (UDisksMDRaid *object,
                                           guint64 value);

Sets the "SyncRemainingTime" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_set_uuid ()

    void
    udisks_mdraid_set_uuid (UDisksMDRaid *object,
                            const gchar *value);

Sets the "UUID" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A UDisksMDRaid. |
value | The value to set. |

Since: 2.0.0

### udisks_mdraid_proxy_new ()

    void
    udisks_mdraid_proxy_new (GDBusConnection *connection,
                             GDBusProxyFlags flags,
                             const gchar *name,
                             const gchar *object_path,
                             GCancellable *cancellable,
                             GAsyncReadyCallback callback,
                             gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.freedesktop.UDisks2.MDRaid. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_proxy_new_finish()` to get the result of the operation.

See `udisks_mdraid_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_proxy_new_finish ()

    UDisksMDRaid *
    udisks_mdraid_proxy_new_finish (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_mdraid_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksMDRaidProxy]

Since: 2.0.0

### udisks_mdraid_proxy_new_sync ()

    UDisksMDRaid *
    udisks_mdraid_proxy_new_sync (GDBusConnection *connection,
                                  GDBusProxyFlags flags,
                                  const gchar *name,
                                  const gchar *object_path,
                                  GCancellable *cancellable,
                                  GError **error);

Synchronously creates a proxy for the D-Bus interface org.freedesktop.UDisks2.MDRaid. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `udisks_mdraid_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksMDRaidProxy]

Since: 2.0.0

### udisks_mdraid_proxy_new_for_bus ()

    void
    udisks_mdraid_proxy_new_for_bus (GBusType bus_type,
                                     GDBusProxyFlags flags,
                                     const gchar *name,
                                     const gchar *object_path,
                                     GCancellable *cancellable,
                                     GAsyncReadyCallback callback,
                                     gpointer user_data);

Like `udisks_mdraid_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `udisks_mdraid_proxy_new_for_bus_finish()` to get the result of the operation.

See `udisks_mdraid_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 2.0.0

### udisks_mdraid_proxy_new_for_bus_finish ()

    UDisksMDRaid *
    udisks_mdraid_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_mdraid_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_mdraid_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksMDRaidProxy]

Since: 2.0.0

### udisks_mdraid_proxy_new_for_bus_sync ()

    UDisksMDRaid *
    udisks_mdraid_proxy_new_for_bus_sync (GBusType bus_type,
                                          GDBusProxyFlags flags,
                                          const gchar *name,
                                          const gchar *object_path,
                                          GCancellable *cancellable,
                                          GError **error);

Like `udisks_mdraid_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `udisks_mdraid_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksMDRaidProxy]

Since: 2.0.0

### udisks_mdraid_skeleton_new ()

    UDisksMDRaid *
    udisks_mdraid_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.freedesktop.UDisks2.MDRaid.

#### Returns

The skeleton object.

[transfer full][type UDisksMDRaidSkeleton]

Since: 2.0.0

## Types and Values

### UDisksMDRaid

    typedef struct _UDisksMDRaid UDisksMDRaid;

Abstract interface type for the D-Bus interface org.freedesktop.UDisks2.MDRaid.

Since: 2.0.0

### struct UDisksMDRaidIface

    struct UDisksMDRaidIface {
      GTypeInterface parent_iface;

      gboolean (*handle_add_device) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_device,
        GVariant *arg_options);

      gboolean (*handle_delete) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_options);

      gboolean (*handle_remove_device) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_device,
        GVariant *arg_options);

      gboolean (*handle_request_sync_action) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_sync_action,
        GVariant *arg_options);

      gboolean (*handle_set_bitmap_location) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_value,
        GVariant *arg_options);

      gboolean (*handle_start) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_options);

      gboolean (*handle_stop) (
        UDisksMDRaid *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_options);

      GVariant * (*get_active_devices) (UDisksMDRaid *object);

      const gchar * (*get_bitmap_location) (UDisksMDRaid *object);

      GVariant * (*get_child_configuration) (UDisksMDRaid *object);

      guint64  (*get_chunk_size) (UDisksMDRaid *object);

      guint  (*get_degraded) (UDisksMDRaid *object);

      const gchar * (*get_level) (UDisksMDRaid *object);

      const gchar * (*get_name) (UDisksMDRaid *object);

      guint  (*get_num_devices) (UDisksMDRaid *object);

      gboolean  (*get_running) (UDisksMDRaid *object);

      guint64  (*get_size) (UDisksMDRaid *object);

      const gchar * (*get_sync_action) (UDisksMDRaid *object);

      gdouble  (*get_sync_completed) (UDisksMDRaid *object);

      guint64  (*get_sync_rate) (UDisksMDRaid *object);

      guint64  (*get_sync_remaining_time) (UDisksMDRaid *object);

      const gchar * (*get_uuid) (UDisksMDRaid *object);
    };

Virtual table for the D-Bus interface org.freedesktop.UDisks2.MDRaid.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_add_device` () | Handler for the “handle-add-device” signal. |
`handle_delete` () | Handler for the “handle-delete” signal. |
`handle_remove_device` () | Handler for the “handle-remove-device” signal. |
`handle_request_sync_action` () | Handler for the “handle-request-sync-action” signal. |
`handle_set_bitmap_location` () | Handler for the “handle-set-bitmap-location” signal. |
`handle_start` () | Handler for the “handle-start” signal. |
`handle_stop` () | Handler for the “handle-stop” signal. |
`get_active_devices` () | Getter for the “active-devices” property. |
`get_bitmap_location` () | Getter for the “bitmap-location” property. |
`get_child_configuration` () | Getter for the “child-configuration” property. |
`get_chunk_size` () | Getter for the “chunk-size” property. |
`get_degraded` () | Getter for the “degraded” property. |
`get_level` () | Getter for the “level” property. |
`get_name` () | Getter for the “name” property. |
`get_num_devices` () | Getter for the “num-devices” property. |
`get_running` () | Getter for the “running” property. |
`get_size` () | Getter for the “size” property. |
`get_sync_action` () | Getter for the “sync-action” property. |
`get_sync_completed` () | Getter for the “sync-completed” property. |
`get_sync_rate` () | Getter for the “sync-rate” property. |
`get_sync_remaining_time` () | Getter for the “sync-remaining-time” property. |
`get_uuid` () | Getter for the “uuid” property. |

Since: 2.0.0

### struct UDisksMDRaidProxy

    struct UDisksMDRaidProxy;

The UDisksMDRaidProxy structure contains only private data and should only be accessed using the provided API.

Since: 2.0.0

### struct UDisksMDRaidProxyClass

    struct UDisksMDRaidProxyClass {
      GDBusProxyClass parent_class;
    };

Class structure for UDisksMDRaidProxy.

#### Members

Since: 2.0.0

### struct UDisksMDRaidSkeleton

    struct UDisksMDRaidSkeleton;

The UDisksMDRaidSkeleton structure contains only private data and should only be accessed using the provided API.

Since: 2.0.0

### struct UDisksMDRaidSkeletonClass

    struct UDisksMDRaidSkeletonClass {
      GDBusInterfaceSkeletonClass parent_class;
    };

Class structure for UDisksMDRaidSkeleton.

#### Members

Since: 2.0.0

## Property Details

### The `“active-devices”` property

      “active-devices”           GVariant *

Represents the D-Bus property "ActiveDevices".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Allowed values: GVariant<a(oiasta{sv})>

Default value: NULL

Since: 2.0.0

### The `“bitmap-location”` property

      “bitmap-location”          gchar *

Represents the D-Bus property "BitmapLocation".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: NULL

Since: 2.0.0

### The `“child-configuration”` property

      “child-configuration”      GVariant *

Represents the D-Bus property "ChildConfiguration".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Allowed values: GVariant<a(sa{sv})>

Default value: NULL

Since: 2.0.0

### The `“chunk-size”` property

      “chunk-size”               guint64

Represents the D-Bus property "ChunkSize".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“degraded”` property

      “degraded”                 guint

Represents the D-Bus property "Degraded".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“level”` property

      “level”                    gchar *

Represents the D-Bus property "Level".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: NULL

Since: 2.0.0

### The `“name”` property

      “name”                     gchar *

Represents the D-Bus property "Name".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: NULL

Since: 2.0.0

### The `“num-devices”` property

      “num-devices”              guint

Represents the D-Bus property "NumDevices".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“running”` property

      “running”                  gboolean

Represents the D-Bus property "Running".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: FALSE

Since: 2.0.0

### The `“size”` property

      “size”                     guint64

Represents the D-Bus property "Size".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“sync-action”` property

      “sync-action”              gchar *

Represents the D-Bus property "SyncAction".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: NULL

Since: 2.0.0

### The `“sync-completed”` property

      “sync-completed”           gdouble

Represents the D-Bus property "SyncCompleted".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“sync-rate”` property

      “sync-rate”                guint64

Represents the D-Bus property "SyncRate".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“sync-remaining-time”` property

      “sync-remaining-time”      guint64

Represents the D-Bus property "SyncRemainingTime".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: 0

Since: 2.0.0

### The `“uuid”` property

      “uuid”                     gchar *

Represents the D-Bus property "UUID".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: UDisksMDRaid

Flags: Read / Write

Default value: NULL

Since: 2.0.0

## Signal Details

### The `“handle-add-device”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_device,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `AddDevice()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_add_device()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_device | Argument passed by remote caller. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0

### The `“handle-delete”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Delete()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_delete()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0

### The `“handle-remove-device”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_device,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `RemoveDevice()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_remove_device()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_device | Argument passed by remote caller. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0

### The `“handle-request-sync-action”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_sync_action,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `RequestSyncAction()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_request_sync_action()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_sync_action | Argument passed by remote caller. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0

### The `“handle-set-bitmap-location”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_value,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `SetBitmapLocation()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_set_bitmap_location()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_value | Argument passed by remote caller. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0

### The `“handle-start”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Start()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_start()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0

### The `“handle-stop”` signal

    gboolean
    user_function (UDisksMDRaid          *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Stop()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_mdraid_complete_stop()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksMDRaid. |
invocation | A GDBusMethodInvocation. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.0.0